#pragma once

#include "stdafx.h"


class FlashFramCommand
{
public:
	//Constructor
	FlashFramCommand();

	void  executeFunction(ActualCommandParams actualCommanParams, DataBlock dataBlock);
	uint32_t retNumBytesResponse();
	DataBuffer retCommandBuffer();
	uint32_t retNewBaudRate();

protected: //to be used also in P432Class

	DataBuffer commandBuffer; //buffer that will be transmitted from bsl scripter to the target device
	uint32_t   numBytesResponse;
	uint32_t   newBaudRate;

	//Header byte BSL commands
	const uint8_t RX_DATA_BLOCK = 0x10;
	const uint8_t RX_PASSWORD = 0x11;
	const uint8_t ERASE_SEGMENT = 0x12;
	const uint8_t TOGGLE_INFO = 0x13;
	const uint8_t ERASE_BLOCK = 0x14;
	const uint8_t MASS_ERASE = 0x15;
	const uint8_t CRC_CHECK = 0x16;
	const uint8_t SET_PC = 0x17;
	const uint8_t TX_DATA_BLOCK = 0x18;
	const uint8_t TX_BSL_VERSION = 0x19;
	const uint8_t TX_BUFFER_SIZE = 0x1A;
	const uint8_t RX_DATA_BLOCK_FAST = 0x1B;

	//Header byte PI
	const uint8_t CHANGE_BAUD_RATE = 0x52;
	const uint8_t BAUD430_4800 = 0x01;
	const uint8_t BAUD430_9600 = 0x02;
	const uint8_t BAUD430_19200 = 0x03;
	const uint8_t BAUD430_38400 = 0x04;
	const uint8_t BAUD430_57600 = 0x05;
	const uint8_t BAUD430_115200 = 0x06;

	void changeBaudRate(ActualCommandParams actualCommandParams);
	void crcCheck(ActualCommandParams actualCommandParams);
	void delay(ActualCommandParams actualCommandParams);
	void eraseSegment(ActualCommandParams actualCommandParams);
	void setPc(ActualCommandParams actualCommandParams);
	void massErase();
	void rxDataBlockFast(ActualCommandParams actualCommandParams, DataBlock dataBlock);
	void rxDataBlock(ActualCommandParams actualCommandParams, DataBlock dataBlock);
	void rxPassword(ActualCommandParams actualCommandParams, DataBlock dataBlock);
	void toggleInfo();
	void txDataBlock(ActualCommandParams actualCommandParams);
	void bslVersion();
	void txBufferSize();
	void verbose();

private:

	//TX_DATA_BLOCK PROPERTIES
	uint32_t maxBufSize ;
	uint32_t maxDataReceive1 ;//first packet
	uint32_t maxDataReceive2 ;
	uint8_t  numHeader1 ;
	uint8_t  numHeader2 ;

	uint32_t totalBytesLeft;
	uint32_t totalBytesReceived;
};

