/*
BSL-Scripter-3.0.1.0

==InterpreterClass.cpp==

Copyright (c) 2008  2015 Texas Instruments Incorporated

All rights reserved not granted herein.

Limited License.

Texas Instruments Incorporated grants a world-wide, royalty-free,
non-exclusive license under copyrights and patents it now or
hereafter owns or controls to make, have made, use, import,
offer to sell and sell ("Utilize") this software subject to
the terms herein.  With respect to the foregoing patent license,
such license is granted  solely to the extent that any such patent
is necessary to Utilize the software alone.  The patent license
shall not apply to any combinations which include this software,
other than combinations with devices manufactured by or for TI
(TI Devices). No hardware patent is licensed hereunder.

Redistributions must preserve existing copyright notices and
reproduce this license (including the above copyright notice
and the disclaimer and (if applicable) source code license
limitations below) in the documentation and/or other materials
provided with the distribution

Redistribution and use in binary form, without modification,
are permitted provided that the following conditions are met:

*	No reverse engineering, decompilation, or disassembly of
this software is permitted with respect to any software
provided in binary form.

*	any redistribution and use are licensed by TI for use only
with TI Devices.

*	Nothing shall obligate TI to provide you with source code
for the software licensed and provided to you in object code.

If software source code is provided to you, modification and
redistribution of the source code are permitted provided that
the following conditions are met:

*	any redistribution and use of the source code, including any
resulting derivative works, are licensed by TI for use only
with TI Devices.

*	any redistribution and use of any object code compiled from
the source code and any resulting derivative works, are licensed
by TI for use only with TI Devices.

Neither the name of Texas Instruments Incorporated nor the names
of its suppliers may be used to endorse or promote products derived
from this software without specific prior written permission.

DISCLAIMER.

THIS SOFTWARE IS PROVIDED BY TI AND TIS LICENSORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL TI AND TIS LICENSORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Version:	Release:		Author:
3.0.1.0		Aug/07/2015		Fatmawati Santosa

*/

#include "stdafx.h"

//Constructor
Interpreter::Interpreter()
{
	//Initialization list
	familyTable[0] = "543x_family";
	familyTable[1] = "5xx";
	familyTable[2] = "6xx";
	familyTable[3] = "frxx";
	familyTable[4] = "p4xx";
	familyTable[5] = "rom";
	familyTable[6] = "msp430f543x";
	familyTable[7] = "msp430f5xx";
	familyTable[8] = "msp430f6xx";
	familyTable[9] = "msp430frxx";
	familyTable[10] = "msp432p4xx";

	protocolTable[0] = "uart";
	protocolTable[1] = "i2c";
	protocolTable[2] = "spi";
	protocolTable[3] = "usb";

	//new version with struct CommandParams
	commandPar[0].commandText = "CHANGE_BAUD_RATE";
	commandPar[1].commandText = "CRC_CHECK_32";
	commandPar[2].commandText = "CRC_CHECK";
	commandPar[3].commandText = "DELAY";
	commandPar[4].commandText = "ERASE_CHECK";
	commandPar[5].commandText = "ERASE_MAIN_OR_INFO";
	commandPar[6].commandText = "ERASE_SEGMENT_32";
	commandPar[7].commandText = "ERASE_SEGMENT";
	commandPar[8].commandText = "SET_PC_32";
	commandPar[9].commandText = "SET_PC";
	commandPar[10].commandText = "MASS_ERASE";
	commandPar[11].commandText = "REBOOT_RESET";
	commandPar[12].commandText = "RX_DATA_BLOCK_FAST";
	commandPar[13].commandText = "RX_DATA_BLOCK_32";
	commandPar[14].commandText = "RX_DATA_BLOCK";
	commandPar[15].commandText = "RX_PASSWORD_32";
	commandPar[16].commandText = "RX_PASSWORD";
	commandPar[17].commandText = "SET_MEMORY_OFFSET";
	commandPar[18].commandText = "TOGGLE_INFO";
	commandPar[19].commandText = "TX_DATA_BLOCK_32";
	commandPar[20].commandText = "TX_DATA_BLOCK";
	commandPar[21].commandText = "TX_BSL_VERSION_32";
	commandPar[22].commandText = "TX_BSL_VERSION";
	commandPar[23].commandText = "TX_BUFFER_SIZE";
	commandPar[24].commandText = "VERBOSE";

	commandPar[0].numOfParamsMand = 1;
	commandPar[1].numOfParamsMand = 2;
	commandPar[2].numOfParamsMand = 2;
	commandPar[3].numOfParamsMand = 1;
	commandPar[4].numOfParamsMand = 2;
	commandPar[5].numOfParamsMand = 1;
	commandPar[6].numOfParamsMand = 1;
	commandPar[7].numOfParamsMand = 1;
	commandPar[8].numOfParamsMand = 1;
	commandPar[9].numOfParamsMand = 1;
	commandPar[10].numOfParamsMand = 0;
	commandPar[11].numOfParamsMand = 0;
	commandPar[12].numOfParamsMand = 1;
	commandPar[13].numOfParamsMand = 1;
	commandPar[14].numOfParamsMand = 1;
	commandPar[15].numOfParamsMand = 0;
	commandPar[16].numOfParamsMand = 0;
	commandPar[17].numOfParamsMand = 1;
	commandPar[18].numOfParamsMand = 0;
	commandPar[19].numOfParamsMand = 3;
	commandPar[20].numOfParamsMand = 3;
	commandPar[21].numOfParamsMand = 0;
	commandPar[22].numOfParamsMand = 0;
	commandPar[23].numOfParamsMand = 0;
	commandPar[24].numOfParamsMand = 0;

	commandPar[0].numOfParamsOpt = 0;
	commandPar[1].numOfParamsOpt = 1;
	commandPar[2].numOfParamsOpt = 1;
	commandPar[3].numOfParamsOpt = 0;
	commandPar[4].numOfParamsOpt = 0;
	commandPar[5].numOfParamsOpt = 0;
	commandPar[6].numOfParamsOpt = 0;
	commandPar[7].numOfParamsOpt = 0;
	commandPar[8].numOfParamsOpt = 0;
	commandPar[9].numOfParamsOpt = 0;
	commandPar[10].numOfParamsOpt = 0;
	commandPar[11].numOfParamsOpt = 0;
	commandPar[12].numOfParamsOpt = 0;
	commandPar[13].numOfParamsOpt = 0;
	commandPar[14].numOfParamsOpt = 0;
	commandPar[15].numOfParamsOpt = 1;
	commandPar[16].numOfParamsOpt = 1;
	commandPar[17].numOfParamsOpt = 0;
	commandPar[18].numOfParamsOpt = 0;
	commandPar[19].numOfParamsOpt = 0;
	commandPar[20].numOfParamsOpt = 0;
	commandPar[21].numOfParamsOpt = 0;
	commandPar[22].numOfParamsOpt = 0;
	commandPar[23].numOfParamsOpt = 0;
	commandPar[24].numOfParamsOpt = 0;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    clearParamsInput
*Description: clear the paramsInput before filled in with the new data
*Parameters:  none
*Returns:     none
*******************************************************************************/
void Interpreter::clearParamsInput()
{
	actualCommandParams.paramsInput[0] = "";
	actualCommandParams.paramsInput[1] = "";
	actualCommandParams.paramsInput[2] = "";
	actualCommandParams.paramsInput[3] = "";
	actualCommandParams.paramsInput[4] = "";
}

/*******************************************************************************
*Class:       Interpreter
*Function:    setupNewBaudRate
*Description: set the new baud rate value into actualCommandParamsStruct
*Parameters:  uint32_t newBaudRate: new baud rate value
*Returns:     none
*******************************************************************************/
void Interpreter::setupNewBaudRate(uint32_t newBaudRate)
{
	actualCommandParams.baudRate = newBaudRate;
}

void Interpreter::interpretCommandParams(string command)
{
	Interpreter::clearParamsInput();

	boost::char_separator<char> sep(",\t\r ");
	boost::tokenizer<boost::char_separator<char>> tokens(command, sep);

	actualCommandParams.numOfParams = 0;
	for (const string& t : tokens)
	{
		actualCommandParams.paramsInput[actualCommandParams.numOfParams] = t;
		actualCommandParams.numOfParams++;
	}

	if (actualCommandParams.paramsInput[0] == "MODE")
	{
		actualCommandParams.repeatMode = 1;
	}
	else
	{
		actualCommandParams.repeatMode = 0;
	}
	actualCommandParams.numOfParams = actualCommandParams.numOfParams - 1;

}

/*******************************************************************************
*Class:       Interpreter
*Function:    checkModeParameters
*Description: set the family, protocl, baud rate value, and max buffer size
*             based on MODE command from the user
*Parameters:  none
*Returns:     none
*******************************************************************************/
void Interpreter::checkModeParameters()
{
	uint8_t i = 0;

	if (actualCommandParams.paramsInput[0] != "MODE")
	{
		throw std::runtime_error("Please enter the MODE command to start the scripter...");
	}
	else
	{
		bool blFamilyValid = false;
		boost::to_lower(actualCommandParams.paramsInput[1]);
		for (int i = 0; i < 11; i++)
		{
			if (actualCommandParams.paramsInput[1] == familyTable[i])
			{
				if (i == 0)      { actualCommandParams.family = Family::F543x; }
				else if (i == 1) { actualCommandParams.family = Family::F5xx; }
				else if (i == 2) { actualCommandParams.family = Family::F6xx; }
				else if (i == 3) { actualCommandParams.family = Family::FRxx; }
				else if (i == 4) { actualCommandParams.family = Family::P4xx; }
				else if (i == 5) { actualCommandParams.family = Family::F543x; }
				else if (i == 6) { actualCommandParams.family = Family::F5xx; }
				else if (i == 7) { actualCommandParams.family = Family::F6xx; }
				else if (i == 8) { actualCommandParams.family = Family::FRxx; }
				else if (i == 9) { actualCommandParams.family = Family::P4xx; }
				else             { actualCommandParams.family = Family::ROM; }

				blFamilyValid = true;
				break;
			}
		}

		if (blFamilyValid == false)
		{
			throw std::runtime_error("Family is not defined...");
		}
		else
		{
			bool protocolValid = false;
			boost::to_lower(actualCommandParams.paramsInput[2]);
			for (int i = 0; i < 4; i++)
			{
				if (actualCommandParams.paramsInput[2] == protocolTable[i])
				{
					if (i == 0)      { actualCommandParams.protocol = Protocol::UART; }
					else if (i == 1) { actualCommandParams.protocol = Protocol::I2C; }
					else if (i == 2) { actualCommandParams.protocol = Protocol::SPI; }
					else             { actualCommandParams.protocol = Protocol::USB; }
					protocolValid = true;		
					break;
				}
			}

			if (protocolValid == false)
			{
				throw std::runtime_error("Protocol is not defined...");
			}
			else
			{
				if (actualCommandParams.protocol == Protocol::USB)
				{
					actualCommandParams.commPort = "";
					actualCommandParams.baudRate = 0;
				}
				else
				{
					if (actualCommandParams.family == Family::P4xx)
					{
						if (actualCommandParams.paramsInput[4] == "")
						{
							actualCommandParams.commPort = actualCommandParams.paramsInput[3];
							actualCommandParams.paramsInput[3].erase(0, 3);
				
							if (actualCommandParams.protocol == Protocol::UART)
							{
								actualCommandParams.baudRate = 9600;
							}
							else if (actualCommandParams.protocol == Protocol::I2C)
							{
								actualCommandParams.baudRate = 100000;
							}
							else if (actualCommandParams.protocol == Protocol::SPI)
							{
								actualCommandParams.baudRate = 125000;
							}
							else
							{
								throw std::runtime_error("Undefined Baud Rate...");
							}
						}
						else
						{
							if (actualCommandParams.protocol == Protocol::UART)
							{
								if (actualCommandParams.paramsInput[3] == "1200") { actualCommandParams.baudRate = 1200; }
								else if (actualCommandParams.paramsInput[3] == "2400") { actualCommandParams.baudRate = 2400; }
								else if (actualCommandParams.paramsInput[3] == "4800") { actualCommandParams.baudRate = 4800; }
								else if (actualCommandParams.paramsInput[3] == "9600") { actualCommandParams.baudRate = 9600;}
								else if (actualCommandParams.paramsInput[3] == "19200") { actualCommandParams.baudRate = 19200; }
								else if (actualCommandParams.paramsInput[3] == "38400") { actualCommandParams.baudRate = 38400; }
								else if (actualCommandParams.paramsInput[3] == "57600") { actualCommandParams.baudRate = 57600; }
								else if (actualCommandParams.paramsInput[3] == "115200") { actualCommandParams.baudRate = 115200; }
								else
								{
									throw std::runtime_error("Undefined Baud Rate...");
								}
							}
							else if (actualCommandParams.protocol == Protocol::I2C)
							{
								if (actualCommandParams.paramsInput[3] == "100000")       { actualCommandParams.baudRate = 100000;}
								else if (actualCommandParams.paramsInput[3] == "400000")  { actualCommandParams.baudRate = 400000;}
								else
								{
									throw std::runtime_error("Undefined Baud Rate...");
								}
							}
							else if (actualCommandParams.protocol == Protocol::SPI)
							{
								if (actualCommandParams.paramsInput[3] == "125000") { actualCommandParams.baudRate = 125000;}
								else if (actualCommandParams.paramsInput[3] == "250000") { actualCommandParams.baudRate = 250000;}
								else if (actualCommandParams.paramsInput[3] == "1000000") { actualCommandParams.baudRate = 1000000;}
								else
								{
									throw std::runtime_error("Undefined Baud Rate...");
								}
							}
							else
							{
								throw std::runtime_error("Undefined Baud Rate...");
							}

							actualCommandParams.commPort = actualCommandParams.paramsInput[4];
						}
					}
					else
					{
						if (actualCommandParams.protocol == Protocol::UART)
						{
							actualCommandParams.baudRate = 9600;
						}
						else if (actualCommandParams.protocol == Protocol::I2C)
						{
							actualCommandParams.baudRate = 100000;
						}
						else if (actualCommandParams.protocol == Protocol::SPI)
						{
							actualCommandParams.baudRate = 125000;
						}
						else
						{
							throw std::runtime_error("Undefined Baud Rate...");
						}
						actualCommandParams.commPort = actualCommandParams.paramsInput[3];
					}
				}

				if (actualCommandParams.protocol == Protocol::USB)
				{
					actualCommandParams.maxBufferSize = 48;
				}
				else
				{
		  			actualCommandParams.maxBufferSize = 240;
				}
			}
		}
	}
}

/*******************************************************************************
*Class:       Interpreter
*Function:    checkCommentLine
*Description: check if the streamed line is a comment line or empty
*Parameters:  std::string command: input line
*Returns:     bool true: it is a comment line or empty line
*             bool false: it is not a comment line or empty line
*******************************************************************************/
bool Interpreter::checkCommentLine(std::string command)
{
	uint8_t pos = command.find_first_of("//");
	bool lineEmpty = command.empty();
	return ((pos == 0) || lineEmpty);
}

/*******************************************************************************
*Class:       Interpreter
*Function:    retCommandIdx
*Description: get the Command identity
*Parameters:  uint8_t idx
*Returns:     Command(enumclass) identity
*******************************************************************************/
Command retCommandIdx(uint16_t idx)
{
	switch (idx)
	{
	case(0)  : return (Command::CHANGE_BAUD_RATE); break;
	case(1)  : return (Command::CRC_CHECK_32); break;
	case(2)  : return (Command::CRC_CHECK); break;
	case(3)  : return (Command::DELAY); break;
	case(4)  : return (Command::ERASE_CHECK); break;
	case(5)  : return (Command::ERASE_MAIN_OR_INFO); break;
	case(6)  : return (Command::ERASE_SEGMENT_32); break;
	case(7)  : return (Command::ERASE_SEGMENT); break;
	case(8)  : return (Command::SET_PC_32); break;
	case(9)  : return (Command::SET_PC); break;
	case(10) : return (Command::MASS_ERASE); break;
	case(11) : return (Command::REBOOT_RESET); break;
	case(12) : return (Command::RX_DATA_BLOCK_FAST); break;
	case(13) : return (Command::RX_DATA_BLOCK_32); break;
	case(14) : return (Command::RX_DATA_BLOCK); break;
	case(15) : return (Command::RX_PASSWORD_32); break;
	case(16) : return (Command::RX_PASSWORD); break;
	case(17) : return (Command::SET_MEMORY_OFFSET); break;
	case(18) : return (Command::TOGGLE_INFO); break;
	case(19) : return (Command::TX_DATA_BLOCK_32); break;
	case(20) : return (Command::TX_DATA_BLOCK); break;
	case(21) : return (Command::TX_BSL_VERSION_32); break;
	case(22) : return (Command::TX_BSL_VERSION); break;
	case(23) : return (Command::TX_BUFFER_SIZE); break;
	case(24) : return (Command::VERBOSE); break;
	default  : return (Command::UNKNOWN_COMMAND); break;
	}
}

/*******************************************************************************
*Class:       Interpreter
*Function:    matchCommand
*Description: match input command with the available commands
*             and check the validity of number of parameters
*Parameters:  none
*Returns:     none
*******************************************************************************/
void Interpreter::matchCommand()
{
	bool match = false;

	for (uint16_t i = 0; i < 25; i++)
	{
		if (boost::algorithm::iequals(actualCommandParams.paramsInput[0], commandPar[i].commandText)) //match the script and the commandsTable
		{
			uint8_t ui8ValidNumOfParams = commandPar[i].numOfParamsMand + commandPar[i].numOfParamsOpt;

			if ((ui8ValidNumOfParams == actualCommandParams.numOfParams) ||
				(commandPar[i].numOfParamsMand == actualCommandParams.numOfParams))
			{
				actualCommandParams.command = retCommandIdx(i);
				match = true;
				break;
			}
			else
			{
				throw "Parameters are invalid...";
			}
		}
	}

	if (match == false)
	{
		throw std::runtime_error("Command is invalid...");
	}
}

/*******************************************************************************
*Class:       Interpreter
*Function:    retActualCommandParams
*Description: return the actualCommandParams to be accessed by the other classes
*Parameters:  none
*Returns:     ActualCommandParams actualCommandParams
*******************************************************************************/
ActualCommandParams Interpreter::retActualCommandParams()
{
	return actualCommandParams;
}


std::string Interpreter::checkHeader(uint8_t *bufHeader, uint8_t *messageReply, uint8_t *coreResponse)
{
	std::string retString;
	switch (*bufHeader)
	{
		case (0x00) :
			{
				if (*messageReply == 0x3B)
				{
					if (*coreResponse == FLASH_WRITE_CHECK_FAILED)
					{
						retString = "Flash write check failed.";
					}
					else if (*coreResponse == FLASH_FAIL_BIT_SET)
					{
						retString = "Flash fail bit set.";
					}
					else if (*coreResponse == VOLTAGE_CHANGE_DURING_PROGRAM)
					{
						retString = "Voltage change during program.";
					}
					else if (*coreResponse == BSL_LOCKED)
					{
						retString = "BSL locked.";
					}
					else if (*coreResponse == BSL_PASSWORD_ERROR)
					{
						retString = "BSL password error.";
					}
					else if (*coreResponse == BYTE_WRITE_FORBIDDEN)
					{
						retString = "BSL byte write forbidden.";
					}
					else
					{
						retString = "Unknown command.";
					}
				}
				else
				{
					retString = "BSL data reply.";
				}
				
			}
			break;

		case (0x51) :
			{
				retString = "Error Header incorrect.";
			}
			break;

		case (0x52) :
			{
				retString = "Error Checksum incorrect.";
			}
			break;

		case (0x53) :
			{
				retString = "Error Packet Size is zero.";
			}
			break;

		case (0x54) :
			{
				retString = "Error Packet Size exceeds the buffer size.";
			}
			break;

		case (0x55) :
			{
				retString = "Unknown error.";
			}
			break;

		case (0x56) :
			{
				retString = "Unknown baud rate.";
			}
			break;

		default:
			retString = " ";
			break;
	}

	return retString;
}
/*******************************************************************************
*Class:       Interpreter
*Function:    retResponse
*Description: switch case to interpret the response based on BSL command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string temp: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::retResponse(uint8_t *buf)
{
	std::string temp;

	switch(actualCommandParams.command)
	{
	case (Command::CHANGE_BAUD_RATE) :
		temp=changeBaudRate(buf);
		break;

	case (Command::CRC_CHECK) :
		temp = crcCheck(buf);
		break;

	case (Command::CRC_CHECK_32) :
		temp = crcCheck(buf);
		break;

	case (Command::ERASE_SEGMENT_32) :
		temp = rxDataBlock(buf);
		break;

	case (Command::ERASE_SEGMENT) :
		temp = rxDataBlock(buf);
		break;

	case (Command::SET_PC) :
		temp = setPC(buf);
		break;

	case (Command::MASS_ERASE) :
		temp = massErase(buf);
		break;

	case (Command::REBOOT_RESET) :
		temp = massErase(buf);
		break;

	case (Command::RX_DATA_BLOCK_FAST) :
		temp = rxDataBlockFast(buf);
		break;

	case (Command::RX_DATA_BLOCK) :
		temp = rxDataBlock(buf);
		break;

	case (Command::RX_DATA_BLOCK_32) :
		temp = rxDataBlock(buf);
		break;

	case (Command::RX_PASSWORD) :
		temp = rxPassword(buf);
		break;

	case (Command::RX_PASSWORD_32) :
		temp = rxDataBlock(buf);
		break;

	case (Command::TOGGLE_INFO) :
		temp = rxDataBlock(buf);
		break;

	case (Command::TX_DATA_BLOCK) :
		temp = txDataBlock(buf);
		break;

	case (Command::TX_BSL_VERSION) :
		temp = txBslVersion(buf);
		break;

	case (Command::TX_BSL_VERSION_32) :
		temp = txBslVersion32(buf);
		break;

	case (Command::TX_BUFFER_SIZE) :
		temp = txBufferSize(buf);
		break;

	default:
		temp = unknownCommand(buf);
		break;
	}

	return temp;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    changeBaudRate
*Description: interpret the response for CHANGE_BAUD_RATE command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::changeBaudRate(uint8_t *buf)
{
 	std::string retString;
	if (buf[0] == 0x00)
	{
		retString= "BSL ACK is received.";
	}
	else
	{
		retString = "Change baud rate error " + intToString(buf[0]);
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    retCrcBsl
*Description: return the crc value from the response
*Parameters:  none
*Returns:     uint16_t crcBsl: crc from BSL device
*******************************************************************************/
uint16_t Interpreter::retCrcBsl()
{
	return crcBsl;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    crcCheck
*Description: interpret the response for CRC_CHECK command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::crcCheck(uint8_t *buf)
{
	std::string retString;
	std::string temp;
	if (((actualCommandParams.protocol == Protocol::UART) ||
		(actualCommandParams.protocol == Protocol::I2C) ||
		(actualCommandParams.protocol == Protocol::SPI)
		)
		&& 
		(buf[0] == SUCCESSFUL_OPERATION) &&
		(buf[1] == HEADER_BYTE) &&
		(buf[2] == 0x03) &&
		(buf[3] == 0x00) &&
		(buf[4] == BSL_DATA_REPLY))
	{
		crcBsl = buf[5] | (buf[6] << 8);
		temp = "0x" + intToHexCrc(crcBsl);
		retString = "CRC check result is : " + temp;

	}
	else if ((actualCommandParams.protocol == Protocol::USB) &&
			 (buf[0] == USB_HEADER_BYTE) &&
			 (buf[1] == 0x03) &&
			 (buf[2] == BSL_DATA_REPLY))
	{
		crcBsl = buf[3] | (buf[4] << 8);
		temp = "0x" + intToHexCrc(crcBsl);
		retString = "CRC check result is : " + temp;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
		return retString;
  	}

	boost::to_upper(actualCommandParams.paramsInput[3]);
	boost::to_upper(temp);

	if ((actualCommandParams.paramsInput[3] != "") &&
		(temp == actualCommandParams.paramsInput[3]))
	{
		retString += "  CRC is matched";
	}
	else if ((actualCommandParams.paramsInput[3] != "") &&
		     (temp != actualCommandParams.paramsInput[3]))
	{
		retString += "  CRC is not matched";
	}
	else
	{
		retString += "  ";
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    setPc
*Description: interpret the response for SET_PC and SET_PC_32 command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::setPC(uint8_t *buf)
{
	std::string retString = "Set PC is sent.";
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    massErase
*Description: interpret the response for MASS_ERASE and REBOOT_RESET command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::massErase(uint8_t *buf)
{
	std::string retString = "";

	if (((actualCommandParams.protocol == Protocol::UART) ||
		(actualCommandParams.protocol == Protocol::I2C) ||
		(actualCommandParams.protocol == Protocol::SPI)
		)
		&&
		((actualCommandParams.family == Family::F5xx) ||
		 (actualCommandParams.family == Family::F6xx) ||
		 (actualCommandParams.family == Family::P4xx)
		)
		&&
		((buf[0] == SUCCESSFUL_OPERATION) &&
		 (buf[1] == HEADER_BYTE) &&
		 (buf[2] == 0x02) &&
		 (buf[3] == 0x00) &&
		 (buf[4] == BSL_MESSAGE_REPLY) &&
		 (buf[5] == 0x00) &&
		 (buf[6] == 0x60) &&
		 (buf[7] == 0xC4)
		)
	   )
	{
		retString = "Data received by BSL.";
	}
	else if ((actualCommandParams.protocol == Protocol::USB) 
		     &&
		     ((actualCommandParams.family == Family::F5xx) ||
		      (actualCommandParams.family == Family::F6xx)
		     ) 
			 &&
			 ((buf[0] == 0x3F) &&
			  (buf[1] == 0x02) &&
			  (buf[2] == 0x3B) &&
			  (buf[3] == 0x00)
			 )
		    )
	{
		retString = "Data received by BSL.";
	}
	else if (actualCommandParams.family == Family::FRxx) 
	{
		resetComm = true;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}


	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    rxDataBlockFast
*Description: interpret the response for RX_DATA_BLOCK_FAST command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::rxDataBlockFast(uint8_t *buf)
{
	std::string retString;
	if (actualCommandParams.protocol == Protocol::USB)
	{
		retString = "BSL ACK is received.";
	}
	else if (((actualCommandParams.protocol == Protocol::UART) ||
		      (actualCommandParams.protocol == Protocol::I2C) ||
			  (actualCommandParams.protocol == Protocol::SPI)
			 )
			 &&
		     (buf[0] == SUCCESSFUL_OPERATION)
		    )
	{
		retString = "BSL ACK is received." ;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    rxDataBlock
*Description: interpret the response for RX_DATA_BLOCK,  RX_DATA_BLOCK_32
              RX_PASSWORD_32 commands
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::rxDataBlock(uint8_t *buf)
{
	std::string retString;
	const uint8_t NUM_BYTES_RESPONSE = 8;

	if (((actualCommandParams.protocol==Protocol::UART)  || 
		 (actualCommandParams.protocol == Protocol::I2C) ||
		 (actualCommandParams.protocol == Protocol::SPI)
		)
		&&
		(buf[0] == SUCCESSFUL_OPERATION) &&
		(buf[1] == HEADER_BYTE) &&
		(buf[2] == 0x02) &&
		(buf[3] == 0x00) &&
		(buf[4] == BSL_MESSAGE_REPLY) &&
		(buf[5] == 0x00) &&
		(buf[6] == 0x60) &&
		(buf[7] == 0xC4))
	{
		retString = "Data received by BSL.";
	}
	else if((actualCommandParams.protocol == Protocol::USB) &&
	    	(buf[0] == 0x3F) &&
		    (buf[1] == 0x02) &&
		    (buf[2] == 0x3B) &&
		    (buf[3] == 0x00)
		   )
	{
		retString = "Data received by BSL.";
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}
/*******************************************************************************
*Class:       Interpreter
*Function:    rxPassword
*Description: interpret the response for RX_PASSWORD
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::rxPassword(uint8_t *buf)
{
	std::string retString;

	if (((actualCommandParams.protocol == Protocol::UART) ||
		 (actualCommandParams.protocol == Protocol::I2C) ||
		 (actualCommandParams.protocol == Protocol::SPI)
		)
		&&
		((buf[0] == 0x00) &&
		 (buf[1] == 0x00) &&
		 (buf[2] == 0x00) &&
		 (buf[3] == 0x00) &&
		 (buf[4] == 0x00) &&
		 (buf[5] == 0x00) &&
		 (buf[6] == 0x00) &&
		 (buf[7] == 0x00)
		)
		&&
		(actualCommandParams.family == Family::FRxx)
	   )

	{
		resetComm = true;
		retString = "Password is incorrect.";
	}
	else if (((actualCommandParams.protocol == Protocol::UART) ||
		      (actualCommandParams.protocol == Protocol::I2C) ||
		      (actualCommandParams.protocol == Protocol::SPI)
		    )
		    &&
		    ((buf[0] == SUCCESSFUL_OPERATION) &&
		     (buf[1] == HEADER_BYTE) &&
		     (buf[2] == 0x02) &&
		     (buf[3] == 0x00) &&
		     (buf[4] == BSL_MESSAGE_REPLY) &&
		     (buf[5] == 0x00) &&
		     (buf[6] == 0x60) &&
		     (buf[7] == 0xC4)
		    )
		   )
	{
		retString = "Password is correct.";
	}
	else if ((actualCommandParams.protocol == Protocol::USB) &&
		(buf[0] == 0x3F) &&
		(buf[1] == 0x02) &&
		(buf[2] == 0x3B) &&
		(buf[3] == 0x00)
		)
	{
		retString = "Password is correct.";
	}
	else if ((actualCommandParams.protocol == Protocol::USB) &&
		(buf[0] == 0x3F) &&
		(buf[1] == 0x02) &&
		(buf[2] == 0x3B) &&
		(buf[3] == 0x05)
		)
	{
		retString = "Password is incorrect.";
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    txDataBlock
*Description: interpret the response for txDataBlock
              TX_DATA_BLOCK,  TX_DATA_BLOCK_32 commands
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::txDataBlock(uint8_t *buf)
{
	std::string retString = "";

	if (actualCommandParams.protocol == Protocol::USB)
	{
		buf[0] = 0x3F;
		retString = checkHeader(&buf[0], &buf[2], &buf[3]);
	}
	else
	{
		retString = checkHeader(&buf[0], &buf[4], &buf[5]);
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    txBslVersion32
*Description: interpret the response TX_BSL_VERSION_32
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::txBslVersion32(uint8_t *buf)
{
	std::string retString;
	if ((buf[0] == SUCCESSFUL_OPERATION) &&
		(buf[1] == HEADER_BYTE) &&
		(buf[2] == 0x0B) &&
		(buf[3] == 0x00) &&
		(buf[4] == BSL_DATA_REPLY)
		)
	{
		bslVersion[0] = (uint16_t)buf[5] | (((uint16_t)buf[6]) << 8);
		bslVersion[1] = (uint16_t)buf[7] | (((uint16_t)buf[8]) << 8);
		bslVersion[2] = (uint16_t)buf[9] | (((uint16_t)buf[10]) << 8);
		bslVersion[3] = (uint16_t)buf[11] | (((uint16_t)buf[12]) << 8);
		bslVersion[4] = (uint16_t)buf[13] | (((uint16_t)buf[14]) << 8);

		std::cout << "BSL Version is : " << std::hex << (int)bslVersion[0];
		std::cout << "." << std::hex << (int)bslVersion[1];
		std::cout << "." << std::hex << (int)bslVersion[2];
		std::cout << "." << std::hex << (int)bslVersion[3];
		std::cout << "." << std::hex << (int)bslVersion[4] << std::endl;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    txBslVersion
*Description: interpret the response TX_BSL_VERSION
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::txBslVersion(uint8_t *buf)
{
	std::string retString;
	if (((actualCommandParams.protocol == Protocol::UART) ||
		 (actualCommandParams.protocol == Protocol::I2C) ||
		 (actualCommandParams.protocol == Protocol::SPI)
	    )
		&&
		(buf[0] == SUCCESSFUL_OPERATION) &&
		(buf[1] == HEADER_BYTE) &&
		(buf[2] == 0x05) &&
		(buf[3] == 0x00) &&
		(buf[4] == BSL_DATA_REPLY)
       )
	{
		bslVersion[0] = buf[5];
		bslVersion[1] = buf[6];
		bslVersion[2] = buf[7];
		bslVersion[3] = buf[8];

		retString = "BSL Version is : " + intToHex(bslVersion[0]) + "." +
			intToHex(bslVersion[1]) + "." +
			intToHex(bslVersion[2]) + "." +
			intToHex(bslVersion[3]) + "." ;
	}
	else if ((actualCommandParams.protocol == Protocol::USB) &&
		     (buf[0] == 0x3F) &&
			 (buf[1] == 0x05) &&
			 (buf[2] == 0x3A)
			)
	{
		bslVersion[0] = buf[3];
		bslVersion[1] = buf[4];
		bslVersion[2] = buf[5];
		bslVersion[3] = buf[6];
		

		retString = "BSL Version is : " + intToHex(bslVersion[0]) + "." +
			intToHex(bslVersion[1]) + "." +
			intToHex(bslVersion[2]) + "." +
			intToHex(bslVersion[3]) + "." ;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    txBufferSize
*Description: interpret the response TX_BUFFER_SIZE
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::txBufferSize(uint8_t *buf)
{
	std::string retString;

	if (((actualCommandParams.protocol == Protocol::UART) ||
		(actualCommandParams.protocol == Protocol::I2C) ||
		(actualCommandParams.protocol == Protocol::SPI)
		)
		&& 
		(buf[0] == SUCCESSFUL_OPERATION) &&
		(buf[1] == HEADER_BYTE) &&
		(buf[2] == 0x03) &&
		(buf[3] == 0x00) &&
		(buf[4] == BSL_DATA_REPLY)
	   )
	{
		bufferSize = buf[5] | (buf[6] << 8 );
		stringstream ss;
		ss << bufferSize;

		retString = "Transmit buffer size is :  : " + ss.str() ;
	}
	else if ((actualCommandParams.protocol == Protocol::USB) &&
		(buf[0] == USB_HEADER_BYTE) &&
		(buf[1] == 0x03) &&
		(buf[2] == 0x00) &&
		(buf[3] == BSL_DATA_REPLY)
		)
	{
		bufferSize = buf[4] | (buf[5] << 8);
		stringstream ss;
		ss << bufferSize;

		retString = "Transmit buffer size is :  : " + ss.str() ;
	}
	else
	{
		if (actualCommandParams.protocol == Protocol::USB)
		{
			buf[0] = 0x00;
			retString = checkHeader(&buf[0], &buf[2], &buf[3]);
		}
		else
		{
			retString = checkHeader(&buf[0], &buf[4], &buf[5]);
		}
	}
	return retString;
}

/*******************************************************************************
*Class:       Interpreter
*Function:    unknownCommand
*Description: interpret the response unknown command
*Parameters:  uint8_t *buf: pointer to the response buffer
*Returns:     std::string retString: string response to be shown for the user
*******************************************************************************/
std::string Interpreter::unknownCommand(uint8_t *buf)
{
	std::string retString = "Unknown command.";
	return retString;
}

bool Interpreter::retResetComm()
{
	return resetComm;
}

void Interpreter::clrResetComm()
{
	resetComm = false;
}

/*******************************************************************************
*Class:       ScripterStream
*Function:    intToHex
*Description: convert the uint8_t type into hex in string type
*             need to cast the uint8_t to uint32_t
*Parameters:  uint8_t input: integer input to be converted to hex
*Returns:     std::string  stream.str(): the string format of hex value
*******************************************************************************/
std::string Interpreter::intToHex(uint8_t input)
{
	std::stringstream stream;
	stream << std::setfill('0')
		<< std::setw(sizeof(input) * 2)
		<< std::hex
		<< (uint32_t)input;
	return stream.str();
}

/*******************************************************************************
*Class:       ScripterStream
*Function:    intToHexCrc
*Description: convert the uint32_t type into hex in string type
*Parameters:  uint8_t input: integer input to be converted to hex
*Returns:     std::string  stream.str(): the string format of hex value
*******************************************************************************/
std::string Interpreter::intToHexCrc(uint16_t input)
{
	std::stringstream stream;
	stream << std::setfill('0')
		<< std::hex
		<< (uint32_t)input;
	return stream.str();
}

/*******************************************************************************
*Class:       ScripterStream
*Function:    intToString
*Description: convert the uint8_t type into hex in string type with '0x' prefix
*Parameters:  uint8_t input: integer input to be converted to hex
*Returns:     std::string  stream.str(): the string format of hex value
*******************************************************************************/
std::string Interpreter::intToString(uint8_t input)
{
	std::stringstream stream;
	stream << std::setfill('0')
		<< std::setw(sizeof(input) * 2)
		<< std::hex << "0x"
		<< (uint32_t)input;
	return stream.str();
}